-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib



Heddframe = Heddframe or CreateFrame("Button","HEDD_MAIN",UIParent)
Heddframe:SetWidth(cfg.isize)
Heddframe:SetHeight(cfg.isize)
Heddframe:SetPoint(unpack(cfg.point))
Heddframe:SetMovable(true)
hedlib.backdrop_texture=cfg.backdrop_texture
hedlib.backdrop_edge_texture=cfg.backdrop_edge_texture
hedlib.CreateBD(Heddframe,cfg.border,{1,0,0,1})
Heddframe.bd:Hide()
Heddframe:Show()
Heddframe:EnableMouse(true)
Heddframe.text = Heddframe.text or hedlib.CreateFont(Heddframe, cfg.textfont, cfg.tsize, "OUTLINE")
Heddframe.text:SetPoint("TOP",Heddframe,"BOTTOM")
Heddframe.text:SetText("")
Heddframe.move = Heddframe.move or CreateFrame("Frame","HEDD_MAIN_move",Heddframe)
Heddframe.move:SetAllPoints(Heddframe)
Heddframe.move:SetFrameStrata("MEDIUM")
Heddframe.move:SetFrameLevel(5)
hedlib.CreateTexture(Heddframe.move)
Heddframe.move.texture:SetTexture(135/255,206/255,235/255,0.5)
Heddframe.move:Hide()

Heddframe.bar=Heddframe.bar or CreateFrame("StatusBar", "HEDD_BAR", Heddframe)
Heddframe.bar:SetWidth(-1)
Heddframe.bar:SetHeight(cfg.bsize)
Heddframe.bar:SetStatusBarTexture(cfg.statusbar_texture)
Heddframe.bar:SetStatusBarColor(124/255, 252/255, 0)
Heddframe.bar.cd = 0
Heddframe.bar.start = cfg.now
Heddframe.bar:SetPoint("RIGHT",Heddframe,"LEFT")
Heddframe.bar.force=nil
Heddframe.bar.lu=cfg.now
Heddframe.bar.spell=nil
Heddframe.bar:Show()

Heddtalents = Heddtalents or CreateFrame("Frame","HEDD_tal",UIParent)
Heddtalents:Show()

Heddframe.DOT = Heddframe.DOT or CreateFrame("Frame","HEDD_DOT",Heddframe)
Heddframe.DOT:SetWidth(cfg.isize)
Heddframe.DOT:SetHeight(cfg.isize)
Heddframe.DOT:SetPoint("LEFT",Heddframe,"RIGHT")
Heddframe.DOT.text = Heddframe.DOT.text or hedlib.CreateFont(Heddframe.DOT, cfg.textfont, cfg.tsize, "OUTLINE")
Heddframe.DOT.text:SetPoint("CENTER",Heddframe.DOT,"CENTER")
Heddframe.DOT.text:SetText("")
Heddframe.DOT.force=nil
hedlib.CreateTexture(Heddframe.DOT)
Heddframe.DOT:Hide()

Heddframe.BUFF = Heddframe.BUFF or CreateFrame("Frame","HEDD_BUFF",Heddframe)
Heddframe.BUFF:SetWidth(cfg.isize)
Heddframe.BUFF:SetHeight(cfg.isize)
Heddframe.BUFF:SetPoint("BOTTOM",Heddframe,"TOP")
hedlib.CreateTexture(Heddframe.BUFF)
--[[Heddframe.BUFF.texture:ClearAllPoints()
Heddframe.BUFF.texture:SetWidth(cfg.isize-2)
Heddframe.BUFF.texture:SetHeight(cfg.isize-2)
Heddframe.BUFF.texture:SetPoint("CENTER",Heddframe.BUFF)]]
local cd = _G["HEDD_BUFF_Cooldown"] or CreateFrame("Cooldown", "$parent_Cooldown", Heddframe.BUFF, "CooldownFrameTemplate")
cd:SetAllPoints(true)
cd:SetFrameLevel(4)
cd:Hide()
Heddframe.BUFF.cooldown=cd
Heddframe.BUFF.text = Heddframe.BUFF.text or hedlib.CreateFont(Heddframe.BUFF, cfg.textfont, cfg.tsize, "OUTLINE")
Heddframe.BUFF.text:SetPoint("BOTTOM",Heddframe.BUFF,"TOP")
Heddframe.BUFF.text:SetText("")
Heddframe.BUFF:Hide()

Heddframe.CD = Heddframe.CD or CreateFrame("Frame","HEDD_CD",Heddframe)
Heddframe.CD:SetWidth(cfg.cdsize)
Heddframe.CD:SetHeight(cfg.cdsize)
Heddframe.CD:SetPoint(unpack(cfg.point_cd))
hedlib.CreateTexture(Heddframe.CD)
Heddframe.CD.texture:SetTexture(135/255,206/255,235/255,0.5 )
Heddframe.CD.texture:Hide()
Heddframe.CD:SetMovable(true)
Heddframe.CD:Show()

cfg.move = false

local move = function()
	if ( cfg.move ) then
		--print("Drag HEDD icon!")
		Heddframe:RegisterForDrag("LeftButton")
		Heddframe:SetScript("OnDragStart", function(Heddframe) Heddframe:StartMoving() end)
		Heddframe:SetScript("OnDragStop", function(Heddframe) 
			Heddframe:StopMovingOrSizing()
			Heddframe:SetUserPlaced(true)
			local x, y = Heddframe:GetLeft(), Heddframe:GetBottom()
			end)
		Heddframe.move:Show()
		Heddframe.CD:RegisterForDrag("LeftButton")
		Heddframe.CD:SetScript("OnDragStart", function() Heddframe.CD:StartMoving() end)
		Heddframe.CD:SetScript("OnDragStop", function() 
			Heddframe.CD:StopMovingOrSizing()
			Heddframe.CD:SetUserPlaced(true)
		end)
		Heddframe.CD:EnableMouse(true)
		Heddframe.CD.texture:Show()
	else
		--print("HEDD icon is pined!")
		Heddframe:RegisterForDrag(nil)
		Heddframe:SetScript("OnDragStart", nil)
		Heddframe:SetScript("OnDragStop", nil)
		Heddframe.move:Hide()
		Heddframe.CD:RegisterForDrag(nil)
		Heddframe.CD:SetScript("OnDragStart", nil)
		Heddframe.CD:SetScript("OnDragStop", nil)
		Heddframe.CD:EnableMouse(nil)
		Heddframe.CD.texture:Hide()
	end
end

HEDDTOGGLELOCKED = function()
	cfg.move = not cfg.move
	move()
end

lib.Hedd_slash = function(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	
	if command=="move" then
		cfg.move = not cfg.move
		move()
	elseif command=="size" then
		if rest ~= "" then
			HeddDB.isize=tonumber(rest) or cfg.isize
			lib.FrameResize(Heddframe,HeddDB.isize)
			lib.FrameResize(Heddframe.DOT,HeddDB.isize)
			lib.FrameResize(Heddframe.BUFF,HeddDB.isize)
--[[			for index,name in pairs(cfg.spells) do
				lib.FrameResize(_G["HEDD_CD_"..index],HeddDB.isize)
			end]]
		else
			print("Syntax: /hedd size [1-9999]");
		end
	elseif command=="bar" then
		if rest ~= "" then
			HeddDB.bsize=tonumber(rest) or cfg.bsize
			Heddframe.bar:SetHeight(HeddDB.bsize)
		else
			print("Syntax: /hedd bar [1-9999]");
		end
	elseif command=="text" then
		if rest ~= "" then
			HeddDB.tsize=tonumber(rest) or cfg.tsize
			hedlib.UpdateFS(Heddframe.text,HeddDB.tsize)
			hedlib.UpdateFS(Heddframe.DOT.text,HeddDB.tsize)
			hedlib.UpdateFS(Heddframe.BUFF.text,HeddDB.tsize)
		else
			print("Syntax: /hedd text [1-9999]");
		end
	elseif command=="cd" then
		if rest ~= "" then
			command, rest = rest:match("^(%S*)%s*(.-)$");
			if command=="size" then
				if rest ~= "" then
					HeddDB.cdsize=tonumber(rest) or cfg.cdsize
					for index,name in pairs(cfg.spells) do
						lib.FrameResize(_G["HEDD_CD_"..index],HeddDB.cdsize)
					end
				else
					print("/hedd cd size [1-9999]");
				end
			elseif command=="hide" then
				if rest ~= "" then
					local spellid=tonumber(rest)
					if spellid and HeddDB.CD[spellid] then
						HeddDB.CD[spellid].hide=true
						lib.CDRefresh()
					end
				end
			elseif command=="show" then
				if rest ~= "" then
					local spellid=tonumber(rest)
					if spellid and HeddDB.CD[spellid] then
						HeddDB.CD[spellid].hide=false
						lib.CDRefresh()
					end
				end
			end
		else
			print("/hedd cd size [1-9999]");
		end
	else
		print("Syntax:")
		print("/hedd move")
		print("/hedd size [1-9999]")
		print("/hedd bar [1-9999]")
		print("/hedd text [1-9999]")
		print("/hedd cd size [1-9999]")
		print("/hedd cd hide [spellid]")
		--print("/hedd cd [spellid] ")
	end
	
end

Heddload = _G["HED_load"] or CreateFrame("Frame","HED_load",UIParent)
Heddload:Show()
Heddload:RegisterEvent("ADDON_LOADED")
local function Hedd_addon_load(self,event,arg1)
	if event == "ADDON_LOADED" and arg1 == "Hedd" then
		Heddload:UnregisterEvent("ADDON_LOADED")
		Heddload:SetScript("OnEvent",nil)
		Heddload:Hide()
		HeddDB = HeddDB or {}
		HeddDB.CD =HeddDB.CD or {}
		lib.MainRefresh()
		lib.Hedd_slash("cd size "..(HeddDB.cdsize or cfg.cdsize))
	end
end
Heddload:SetScript("OnEvent", Hedd_addon_load);

SLASH_HEDD1 = "/Hedd"
SLASH_HEDD2 = "/hedd"
SlashCmdList["HEDD"] = lib.Hedd_slash;

local Hedd_Tooltip = _G["Hedd_Tooltip"] or CreateFrame('GameTooltip', 'Hedd_Tooltip', UIParent, 'GameTooltipTemplate')
Hedd_Tooltip:SetOwner(UIParent, 'ANCHOR_NONE')
Heddframe.Hedd_Tooltip=Hedd_Tooltip
Heddframe.Hedd_Tooltip:Hide()
